#pragma once

#include "CuckooHashMap.h"

#include <TNL/Containers/StaticArray.h>


template<typename K, typename V, typename Device>
CuckooHashMap<K, V, Device>::CuckooHashMap(const CuckooHashMap<K, V, Device>& other) : CuckooHashTable<Pair<K, V>, K, Device>(other) {}

template<typename K, typename V, typename Device>
CuckooHashMap<K, V, Device>::CuckooHashMap(const Array<Pair<K, V>, Device>& values, uint8_t nHashFunctions) :
    CuckooHashTable<Pair<K, V>, K, Device>(values, nHashFunctions) {}

template<typename K, typename V, typename Device>
CuckooHashMap<K, V, Device>::CuckooHashMap(int tableSize, uint8_t nHashFunctions, int nIters, 
                                           const std::vector<std::pair<K, V>>& values) : 
                                            CuckooHashTable<Pair<K, V>, K, Device>(tableSize,
                                                                                   nHashFunctions,
                                                                                   nIters,
                                                                                   Pair<K, V>::template fill<Device>(values)) {}

template<typename K, typename V, typename Device>
bool CuckooHashMap<K, V, Device>::find(const K& key, V& value) const {
    Array<Pair<K, V>, Device> item(1);
    if (!this->m_view->find(key, item.getView()))
        return false;
    value = item.getElement(0).value;
    return true;
}
