#pragma once

#include "CuckooHashSet.h"

#include <TNL/Containers/StaticArray.h>


template<typename T, typename Device>
CuckooHashSet<T, Device>::CuckooHashSet(const CuckooHashSet<T, Device>& other) : CuckooHashTable<Value<T>, T, Device>(other) {}

template<typename T, typename Device>
CuckooHashSet<T, Device>::CuckooHashSet(CuckooHashSet<T, Device>&& other) : CuckooHashTable<Value<T>, T, Device>(other) {}

template<typename T, typename Device>
CuckooHashSet<T, Device>::CuckooHashSet(const Array<T, Device>& values, uint8_t nHashFunctions) :
    CuckooHashTable<Value<T>, T, Device>(Value<T>::template fill<Device>(values), nHashFunctions) {}

template<typename T, typename Device>
CuckooHashSet<T, Device>::CuckooHashSet(int tableSize, uint8_t nHashFunctions, int nIters, 
                                        const Array<T, Device>& values) : 
                                            CuckooHashTable<Value<T>, T, Device>(tableSize,
                                                                                 nHashFunctions,
                                                                                 nIters,
                                                                                 std::move(Value<T>::fill(values))) {}

template<typename T, typename Device>
bool CuckooHashSet<T, Device>::contains(const T& value) const {
    Array<Value<T>, Device> item(1);
    return this->m_view->find(value, item.getView());
}
