#pragma once

#include "RandomIntGenerator.h"

#include <TNL/Cuda/CudaCallable.h>

#include <cstdlib>


#define PRIME 334214459


template <typename T>
struct HashFunction {
    __cuda_callable__ HashFunction() {}
    __cuda_callable__ HashFunction(int a, int b, int max);
    __cuda_callable__ HashFunction(RandomIntGenerator& rand, int max);
    __cuda_callable__ int operator()(const T& value) const;
    __cuda_callable__ void init(RandomIntGenerator& rand, int max);

    int a, b, max;
    __cuda_callable__ size_t hash(const T& value) const;
};

#include "HashFunction.hpp"
