#pragma once

#include "HashGraphV1/HashGraphV1.h"
#include "HashGraphV2/HashGraphV2.h"
//#include "HashGraphS/HashGraphS.h"

#include <TNL/Containers/Array.h>
#include <TNL/Devices/Host.h>

#include "../Pair.hpp"

using namespace TNL::Containers;


template<template<class, class, class> class HG, typename K, typename V, typename Device = TNL::Devices::Host>
class HashGraphMap : public HG<Pair<K, V>, K, Device> {
  public:
    HashGraphMap(const Array<Pair<K, V>, Device>& values);
    bool find(const K& key, V& value) const;
};


#include "HashGraphMap.hpp"
