#pragma once

#include "HashGraphMap.h"

#include <TNL/Containers/StaticArray.h>
#include <TNL/Devices/Host.h>


template<template<class, class, class> class HG, typename K, typename V, typename Device>
HashGraphMap<HG, K, V, Device>::HashGraphMap(const Array<Pair<K, V>, Device>& values) : 
    HG<Pair<K, V>, K, Device>(values) {}

template<template<class, class, class> class HG, typename K, typename V, typename Device>
bool HashGraphMap<HG, K, V, Device>::find(const K& key, V& value) const {
    Array<Pair<K, V>, Device> item(1);
    if (HG<Pair<K, V>, K, Device>::find(key, item.getView())) {
        value = item.getElement(0).value;
        return true;
    }
    return false;
}


template<typename K, typename V, typename Device>
using HashGraphV1Map = HashGraphMap<HashGraphV1, K, V, Device>;

template<typename K, typename V, typename Device>
using HashGraphV2Map = HashGraphMap<HashGraphV2, K, V, Device>;

// template<typename K, typename V, typename Device>
// using HashGraphSMap = HashGraphMap<HashGraphS, K, V, Device>;
