#pragma once

#include "../../HashFunction.h"
#include "HashGraphSView.h"

#include <TNL/Algorithms/Segments/CSR.h>
#include <TNL/Containers/Array.h>
#include <TNL/Containers/Vector.h>

#include <vector>


using namespace TNL::Algorithms::Segments;
using namespace TNL::Containers;

// template<typename Item, typename Key, typename Device>
// class HashGraphV1View;

template<typename Item, typename Key, typename Device>
class HashGraphS {
    using ViewType = HashGraphSView<Item, Key, Device>;
    using Self = HashGraphS<Item, Key, Device>;
    friend ViewType::HashGraphSView(Self&, const typename Array<Item, Device>::ConstViewType,
                                    ArrayView<int, Device>);

  public:
    void debug_print() const {
      // std::cout << "CONTENT" << std::endl;
      // std::cout << m_content << std::endl;
      // std::cout << "ITEMS" << std::endl;
      // std::cout << m_items << std::endl;
      // std::cout << "OFFSET" << std::endl;
      // std::cout << m_offset << std::endl;
    }
    int duplicates() const;

  protected:
    HashGraphS(const Array<Item, Device>& items);
    bool find(const Key& key, ArrayView<Item, Device> item) const;

  private:
    Array<Item, Device> m_content;
    Vector<int, Device> m_segmentSizes;
    CSR<Device, int> m_csr;
    Array<int, Device> m_table;
};


#include "HashGraphS.hpp"
