#pragma once

#include "HashGraphS.h"

#include "HashGraphSView.h"

#include "../../RandomIntGenerator.h"

#include <TNL/Containers/Array.h>


template<typename Item, typename Key, typename Device>
HashGraphS<Item, Key, Device>::HashGraphS(const Array<Item, Device>& items) :
            m_content(items),
            m_segmentSizes(items.getSize()),
            m_csr(items.getSize()),
            m_table(m_csr.getStorageSize()),
            m_view(*this, items.getConstView()) {}

template<typename Item, typename Key, typename Device>
int HashGraphS<Item, Key, Device>::duplicates() const {
    // TODO
    return -1;
}

template<typename Item, typename Key, typename Device>
bool HashGraphS<Item, Key, Device>::find(const Key& key, ArrayView<Item, Device> item) const {
    return m_view->find(key, item);
}
