#pragma once

#include "HashGraphSet.h"

#include <TNL/Containers/StaticArray.h>


template<template<class, class, class> class HG, typename T, typename Device>
HashGraphSet<HG, T, Device>::HashGraphSet(const Array<T, Device>& values) : HG<Value<T>, T, Device>(Value<T>::fill(values)) {}


template<template<class, class, class> class HG, typename T, typename Device>
bool HashGraphSet<HG, T, Device>::contains(const T& value) const {
    Array<Value<T>, Device> item(1);
    return HG<Value<T>, T, Device>::find(value, item.getView());
}


template<typename T, typename Device = TNL::Devices::Host>
using HashGraphV1Set = HashGraphSet<HashGraphV1, T, Device>;

template<typename T, typename Device = TNL::Devices::Host>
using HashGraphV2Set = HashGraphSet<HashGraphV2, T, Device>;

// template<typename T, typename Device>
// using HashGraphSSet = HashGraphSet<HashGraphS, T, Device>;
