#pragma once

#include "../../HashFunction.h"
#include "HashGraphV1View.h"

#include <TNL/Containers/Array.h>

#include <vector>


using namespace TNL::Containers;

// template<typename Item, typename Key, typename Device>
// class HashGraphV1View;

template<typename Item, typename Key, typename Device>
class HashGraphV1 {
    using ViewType = HashGraphV1View<Item, Key, Device>;
    using Self = HashGraphV1<Item, Key, Device>;
    friend ViewType::HashGraphV1View(Self*);

  public:
    void debug_print() const {
      std::cout << "CONTENT" << std::endl;
      std::cout << m_content << std::endl;
      std::cout << "ITEMS" << std::endl;
      std::cout << m_items << std::endl;
      std::cout << "OFFSET" << std::endl;
      std::cout << m_offset << std::endl;
      
    }
    int duplicates() const;

  protected:
    HashGraphV1(const Array<Item, Device>& items);
    bool find(const Key& key, ArrayView<Item, Device> item) const;

  private:
    Array<Item, Device> m_content;
    Array<int, Device> m_items;
    Array<int, Device> m_offset;
    std::shared_ptr<ViewType> m_view;
  
};


#include "HashGraphV1.hpp"
