#pragma once

#include "HashGraphV1.h"

#include "HashGraphV1View.h"

#include "../../RandomIntGenerator.h"

#include <TNL/Containers/Array.h>


template<typename Item, typename Key, typename Device>
HashGraphV1<Item, Key, Device>::HashGraphV1(const Array<Item, Device>& items) :
            m_content(items),
            m_items(items.getSize()),
            m_offset((1 << int(ceil(log2(items.getSize())))) + 1, 0),
            m_view(std::make_shared<ViewType>(this)) {}

template<typename Item, typename Key, typename Device>
int HashGraphV1<Item, Key, Device>::duplicates() const {
    return -1;
}

template<typename Item, typename Key, typename Device>
bool HashGraphV1<Item, Key, Device>::find(const Key& key, ArrayView<Item, Device> item) const {
    return m_view->find(key, item);
}
