#pragma once

#include "HashGraphV1.h"

#include "../../HashFunction.h"

#include <TNL/Containers/Array.h>

#include <vector>


using namespace TNL::Containers;

template<typename Item, typename Key, typename Device>
class HashGraphV1;

template<typename Item, typename Key, typename Device>
class HashGraphV1View {
    using TableType = HashGraphV1<Item, Key, Device>;

  public:
    HashGraphV1View(TableType* table);
    ~HashGraphV1View();
    int duplicates() const;

    bool find(const Key& key, ArrayView<Item, Device> item) const;

    void build();

    void fill_offset(const ArrayView<int, Device>& counter);

  private:
    ArrayView<Item, Device> place_items();

    ArrayView<Item, Device> m_content;
    ArrayView<int, Device> m_items;
    ArrayView<int, Device> m_offset;
    HashFunction<Key> m_hash;
  
};


#include "HashGraphV1View.hpp"
