#pragma once

#include "../../HashFunction.h"
#include "HashGraphV2View.h"

#include <TNL/Containers/Array.h>

#include <vector>


using namespace TNL::Containers;


template<typename Item, typename Key, typename Device>
class HashGraphV2 {
    using Self = HashGraphV2<Item, Key, Device>;
    using ViewType = HashGraphV2View<Item, Key, Device>;
    friend ViewType::HashGraphV2View(Self*);
  public:
    int duplicates() const;
    void debug_print() const {
      for (int i = 0; i < m_content.getSize(); i++)
        std::cout << m_content.getElement(i).key << ' ';
      std::cout << std::endl;
      std::cout << m_items << std::endl;
      std::cout << m_offset << std::endl;
    }

  protected:
    HashGraphV2(const Array<Item, Device>& items);
    ~HashGraphV2();
    bool find(const Key& key, ArrayView<Item, Device> item) const;

  private:
    void fill_offset(const Array<int, Device>& counter, Array<int, Device>& offset);

    Array<Item, Device> m_content;
    Array<int, Device> m_items;
    Array<int, Device> m_offset;
    ViewType* m_view;
};


#include "HashGraphV2.hpp"
