#pragma once

#include "HashGraphV2.h"


template<typename Item, typename Key, typename Device>
HashGraphV2<Item, Key, Device>::HashGraphV2(const Array<Item, Device>& items) :
            m_content(items),
            m_items(items.getSize()),
            m_offset((1 << int(ceil(log2(m_content.getSize())))) + 1),
            m_view(new ViewType(this)) {
    /*int nBins = items.getSize() / 16;
    int binSize = items.getSize() / nBins + (items.getSize() % nBins > 0);
    int tableSize = nBins * binSize;
    Array<int> binCounter(nBins, 0);
    for (int i = 0; i < items.getSize(); i++)
        binCounter[m_hash(items[i].key()) / binSize]++;
    Array<int> binOffset;
    fill_offset(binCounter, binOffset);
    Array<Item> reorg(tableSize);
    for (int i = 0; i < reorg.getSize(); i++)
        new ((void*) &reorg[i]) Item(m_default);
    for (int i = 0; i < items.getSize(); i++) {
        int bin = m_hash(items[i].key()) / binSize;
        int pos = (binCounter[bin]++) + binOffset[bin];
        reorg[pos].~Item();
        new ((void*) &reorg[pos]) Item(items[i]);
    }
    Array<int> counter(tableSize, 0);
    for (int i = 0; i < reorg.getSize(); i++) {
        int pos = m_hash(reorg[i].key());
        counter[pos]++;
    } 
    for (int i = 0; i < reorg.getSize(); i++)
        reorg[i].~Item();
    fill_offset(counter, m_offset);
    std::cout << m_offset << std::endl;
    std::cout << counter << std::endl;
    m_items.setSize(tableSize);
    counter.setValue(0);
    for (int i = 0; i < items.getSize(); i++) {
        if constexpr (std::is_same<Key, std::string>::value) {
            if (items[i].key() == "Rapla" || items[i].key() == "Compostela")
                int a = 0;
        }
        int hash = m_hash(items[i].key());
        //int pos = m_offset[hash] +`
        (counter[hash]++);
        new ((void*) &m_items[pos]) Item(items[i]);
    }
    for (int i = 0; i < items.getSize(); i++)
        items[i].~Item();*/
}

template<typename Item, typename Key, typename Device>
HashGraphV2<Item, Key, Device>::~HashGraphV2() {
    delete m_view;
}

template<typename Item, typename Key, typename Device>
bool HashGraphV2<Item, Key, Device>::find(const Key& key, ArrayView<Item, Device> item) const {
    return m_view->find(key, item);
}

template<typename Item, typename Key, typename Device>
int HashGraphV2<Item, Key, Device>::duplicates() const {
    return -1;
}

// template<typename Item, typename Key>
// void HashGraphV2<Item, Key, Device>::fill_offset(const Array<int>& counter, Array<int>& offset) {
//     int latestOffset = 0;
//     offset.setSize(counter.getSize() + 1);
//     for (int i = 0; i < counter.getSize(); i++) {
//         offset[i] = latestOffset;
//         latestOffset += counter[i];
//     }
//     offset[counter.getSize()] = latestOffset;
// }
