#pragma once

#include "HashGraphV2.h"

#include <TNL/Containers/ArrayView.h>

using namespace TNL::Containers;

template<typename Item, typename Key, typename Device>
class HashGraphV2;


template<typename Item, typename Key, typename Device>
class HashGraphV2View {
    using TableType = HashGraphV2<Item, Key, Device>;
  public:
    void build();
    HashGraphV2View(TableType* table);
    ~HashGraphV2View();
    bool find(const Key& key, ArrayView<Item, Device> item) const;
    void fill_offset(const ArrayView<int, Device>& counter, ArrayView<int, Device> offset);

  private:
    ArrayView<Item, Device> m_content;
    ArrayView<int, Device> m_items;
    ArrayView<int, Device> m_offset;
    HashFunction<Key> m_hash;
};

#include "HashGraphV2View.hpp"
