#pragma once

#include <TNL/Containers/Array.h>

#include <memory>


template<typename K, typename V> struct Pair {
    __cuda_callable__ Pair(K key=K(), V value=V()) : key(key), value(value) {}

    __cuda_callable__ Pair& operator=(const Pair& other) {
        this->key = other.key;
        this->value = other.value;
        return *this;
    }

    __cuda_callable__ bool operator==(const Pair& other) {
        return this->key == other.key && this->value == other.value;
    }

    K key;
    V value;
};

template<typename K, typename V>
std::ostream& operator<<(std::ostream& os, const Pair<K, V>& pair) {
    return (os << '<' << pair.key << ", " << pair.value << '>');
}
