#pragma once

#include <cassert>
#include <climits>
#include <ctime>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <string>
#include <sstream>
#include <vector>

#ifdef HAVE_CUDA
#include <TNL/Devices/Cuda.h>
using Device = TNL::Devices::Cuda;
#else
#include <TNL/Devices/Host.h>
using Device = TNL::Devices::Host;
#endif

#define N_HASH_FUNCTIONS 6

#define BEGIN_TEST(NAME) std::cerr << "\tTESTING " << #NAME << std::endl;\
                         clock_t start = clock();

#define END_TEST clock_t end = clock();\
                 g_results[g_row][g_col] = double(end - start) / CLOCKS_PER_SEC;\
                 std::cerr << "\t\tTime elapsed: "\
                           << g_results[g_row][g_col++]\
                           << 's' << std::endl << std::endl;
